(function () {
  'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
  }

  function _iterableToArrayLimit(arr, i) {
    if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var version = "0.0.0-development";
  var author = "Tom Scott <tubbo@psychedeli.ca>";
  var license = "MIT";

  Array.prototype.includes||Object.defineProperty(Array.prototype,"includes",{value:function(r,e){if(null==this)throw new TypeError('"this" is null or not defined');var t=Object(this),n=t.length>>>0;if(0===n)return !1;for(var i=0|e,o=Math.max(i>=0?i:n-Math.abs(i),0);o<n;){if(function(r,e){return r===e||"number"==typeof r&&"number"==typeof e&&isNaN(r)&&isNaN(e)}(t[o],r))return !0;o++;}return !1}});

  var PRICE_BIN = 30;
  var PRICE_BENCH = 50;
  function Add(settings) {
    var paths = {
      unsloped: [],
      sloped: []
    };
    var benchIndexes = settings.benches.map(function (b) {
      return b.index;
    });
    var binIndexes = settings.bins.map(function (b) {
      return b.index;
    });

    var conflictsWithExistingAddition = function conflictsWithExistingAddition(path) {
      return settings.preserveOtherAdditions && path.addition !== null && !benchIndexes.includes(path.addition) && !binIndexes.includes(path.addition);
    };

    var useMoney = !park.getFlag("noMoney"); // Iterate every tile in the map

    var _loop = function _loop(y) {
      var _loop2 = function _loop2(x) {
        var _map$getTile = map.getTile(x, y),
            elements = _map$getTile.elements;

        var surface = elements.filter(function (element) {
          return element.type === "surface";
        })[0];
        var footpaths = elements.filter(function (element) {
          return element.type === "footpath";
        });
        footpaths.forEach(function (path) {
          if (!canBuildAdditionOnPath(surface, path)) {
            return;
          }

          if (conflictsWithExistingAddition(path)) {
            return;
          }

          if ((path === null || path === void 0 ? void 0 : path.slopeDirection) === null) {
            paths.unsloped.push({
              path: path,
              x: x,
              y: y
            });
          } else {
            paths.sloped.push({
              path: path,
              x: x,
              y: y
            });
          }
        });
      };

      for (var x = 0; x < map.size.x; x++) {
        _loop2(x);
      }
    };

    for (var y = 0; y < map.size.y; y++) {
      _loop(y);
    } // Build benches and bins on unsloped paths


    paths.unsloped.forEach(function (_ref) {
      var path = _ref.path,
          x = _ref.x,
          y = _ref.y;
      var bench = settings.bench,
          bin = settings.bin;

      var _findAdditionAndPrice = findAdditionAndPrice(bench, bin, x, y),
          _findAdditionAndPrice2 = _slicedToArray(_findAdditionAndPrice, 2),
          addition = _findAdditionAndPrice2[0],
          price = _findAdditionAndPrice2[1];

      var cash = park.cash - price;

      if (useMoney && cash >= 0) {
        ensureHasAddition(path, addition, price);
      } else if (!useMoney) {
        ensureHasAddition(path, addition, 0);
      } else {
        throw new Error("Insufficient funds.");
      }
    }); // Build bins on sloped paths

    paths.sloped.forEach(function (_ref2) {
      var path = _ref2.path,
          x = _ref2.x,
          y = _ref2.y;
      var cash = park.cash - PRICE_BIN;
      var affordable = cash >= 0;
      var buildBinsOnAllSlopedPaths = settings.buildBinsOnAllSlopedPaths;
      var evenTile = x % 2 === y % 2;
      var buildOnSlopedPath = buildBinsOnAllSlopedPaths || evenTile;

      if (useMoney && buildOnSlopedPath && affordable) {
        ensureHasAddition(path, settings.bin, PRICE_BIN);
      } else if (!useMoney && buildOnSlopedPath) {
        ensureHasAddition(path, settings.bin, 0);
      }
    });
  }

  function ensureHasAddition(path, addition, price) {
    if (path.addition !== addition || path.isAdditionBroken) {
      path.addition = addition;
      path.isAdditionBroken = false;
      path.isAdditionGhost = false;
      park.cash -= price;
    }
  }

  function findAdditionAndPrice(bench, bin, x, y) {
    if (x % 2 === y % 2) {
      return [bench, PRICE_BENCH];
    } else {
      return [bin, PRICE_BIN];
    }
  }

  function canBuildAdditionOnPath(surface, path) {
    if (!surface || !path) {
      return false;
    }

    if (path.isQueue) {
      return false;
    }

    if (surface.hasOwnership) {
      return true;
    } // Only allowed to build underground or elevated on land with construction rights


    if (surface.hasConstructionRights && surface.baseHeight !== path.baseHeight) {
      return true;
    }

    return false;
  }

  var BENCH = "Benchwarmer.Bench";
  var BIN = "Benchwarmer.Bin";
  var BUILD = "Benchwarmer.BuildOnAllSlopedFootpaths";
  var PRESERVE = "Benchwarmer.PreserveOtherAdditions";

  var Settings = /*#__PURE__*/function () {
    function Settings(all) {
      _classCallCheck(this, Settings);

      this.benches = all.filter(function (a) {
        return a.identifier.includes("bench");
      });
      this.bins = all.filter(function (a) {
        return a.identifier.includes("litter");
      });
    }

    _createClass(Settings, [{
      key: "bench",
      get: function get() {
        return this.benches[this.selections.bench].index;
      },
      set: function set(number) {
        context.sharedStorage.set(BENCH, number);
      }
    }, {
      key: "bin",
      get: function get() {
        return this.bins[this.selections.bin].index;
      },
      set: function set(number) {
        context.sharedStorage.set(BIN, number);
      }
    }, {
      key: "selections",
      get: function get() {
        var bench = context.sharedStorage.get(BENCH, 0);
        var bin = context.sharedStorage.get(BIN, 0);
        return {
          bench: bench,
          bin: bin
        };
      }
    }, {
      key: "buildBinsOnAllSlopedPaths",
      get: function get() {
        return context.sharedStorage.get(BUILD, false);
      },
      set: function set(value) {
        context.sharedStorage.set(BUILD, value);
      }
    }, {
      key: "preserveOtherAdditions",
      get: function get() {
        return context.sharedStorage.get(PRESERVE, true);
      },
      set: function set(value) {
        context.sharedStorage.set(PRESERVE, value);
      }
    }, {
      key: "configured",
      get: function get() {
        return this.bench !== null && this.bin !== null;
      }
    }]);

    return Settings;
  }();

  var LABEL_X = 10;
  var INPUT_X = 70;
  var y = 0;
  function Document() {
    y = 0;

    for (var _len = arguments.length, widgets = new Array(_len), _key = 0; _key < _len; _key++) {
      widgets[_key] = arguments[_key];
    }

    return widgets;
  }
  function Dropdown(text, choices, selectedIndex, onChange) {
    var items = choices.map(function (b) {
      return "".concat(b.name, " ").concat(b.identifier);
    });
    y += 20;
    return [{
      type: "label",
      x: LABEL_X,
      y: y,
      width: 50,
      height: 10,
      text: text
    }, {
      type: "dropdown",
      x: INPUT_X,
      y: y,
      width: 200,
      height: 10,
      items: items,
      selectedIndex: selectedIndex,
      onChange: onChange
    }];
  }
  function Checkbox(text, isChecked, onChange) {
    y += 15;
    return {
      type: "checkbox",
      x: LABEL_X,
      y: y,
      width: 200,
      height: 15,
      isChecked: isChecked,
      text: text,
      onChange: onChange
    };
  }
  function Button(text, onClick) {
    y += 20;
    return {
      type: "button",
      text: text,
      x: 10,
      y: y,
      width: 50,
      height: 20,
      onClick: onClick
    };
  }

  var name = "Benchwarmer";

  function main() {
    ui.registerMenuItem(name, function () {
      var additions = context.getAllObjects("footpath_addition");
      var settings = new Settings(additions);
      var window = ui.openWindow({
        title: name,
        id: 1,
        classification: name,
        width: 300,
        height: 115,
        widgets: Document.apply(void 0, _toConsumableArray(Dropdown("Bench:", settings.benches, settings.selections.bench, function (number) {
          settings.bench = number;
        })).concat(_toConsumableArray(Dropdown("Bin:", settings.bins, settings.selections.bin, function (number) {
          settings.bin = number;
        })), [Checkbox("Build bins on all sloped footpaths", settings.buildBinsOnAllSlopedPaths, function (checked) {
          settings.buildBinsOnAllSlopedPaths = checked;
        }), Checkbox("Preserve other additions (e.g. lamps)", settings.preserveOtherAdditions, function (checked) {
          settings.preserveOtherAdditions = checked;
        }), Button("Add", function () {
          if (settings.configured) {
            try {
              Add(settings);
            } catch (e) {
              ui.showError("Error Building Benches/Bins", e.message);
            }
          }

          window.close();
        })]))
      });
    });
  }

  registerPlugin({
    name: name,
    version: version,
    licence: license,
    authors: [author],
    type: "local",
    main: main
  });

}());
